apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ k8s_headlamp_release }}-prometheus-proxy-source
data:
  server.js: |
    const http = require("http");
    const https = require("https");
    const httpProxy = require("http-proxy");
    const PROMETHEUS_PROXY_URL = process.env.PROMETHEUS_PROXY_URL || null;
    if (!PROMETHEUS_PROXY_URL) {
      console.error("Prometheus proxy url not defined. Set 'PROMETHEUS_PROXY_URL'");
      process.exit(1);
    }
    
    const PROMETHEUS_PROXY_SECURE = (process.env.PROMETHEUS_PROXY_SECURE || "true").toLowerCase() === true;
    const PORT = process.env.PROMETHEUS_PROXY_PORT || 9090;
    const proxy = httpProxy.createProxyServer({
      target: PROMETHEUS_PROXY_URL,
      changeOrigin: true,
      secure: PROMETHEUS_PROXY_SECURE,
      agent: new https.Agent({ rejectUnauthorized: false }),
    });

    console.log(`Running proxy for ${PROMETHEUS_PROXY_URL} [${PROMETHEUS_PROXY_SECURE && ("https" in PROMETHEUS_PROXY_URL) ? "secure" : "insecure"}]`);
    const server = http.createServer((req, res) => {
      proxy.web(req, res, {}, (err) => {
        console.error("Proxy error:", err);
        res.writeHead(502);
        res.end("Bad gateway");
      });
    });

    server.listen(PORT, "0.0.0.0", () => {
      console.log(`Proxy server running on port ${PORT}`);
    });
